#include "CResidenceTime.h"

using namespace std;
using namespace NApi;
using namespace NApiCore;
using namespace NApiPbf;

const string CResidenceTime::RESIDENCE_TIME_PROPERTY = "Residence Time";

CResidenceTime::CResidenceTime()
{
    ;
}

CResidenceTime::~CResidenceTime()
{
    ;
}

bool CResidenceTime::isThreadSafe()
{
    // thread safe
    return true;
}

bool CResidenceTime::usesCustomProperties()
{
    // Uses custom properties
    return true;
}

ECalculateResult CResidenceTime::externalForce(double       time,
                                               double       timestep,
                                               int          id,
                                               const char   type[],
                                               double       mass,
                                               double       volume,
                                               double       posX,
                                               double       posY,
                                               double       posZ,
                                               double       velX,
                                               double       velY,
                                               double       velZ,
                                               double       angVelX,
                                               double       angVelY,
                                               double       angVelZ,
                                               double       charge,
                                               const double orientation[9],
                                               NApiCore::ICustomPropertyDataApi_1_0* particlePropData,
                                               NApiCore::ICustomPropertyDataApi_1_0* simulationPropData,
                                               double&      calculatedForceX,
                                               double&      calculatedForceY,
                                               double&      calculatedForceZ,
                                               double&      calculatedTorqueX,
                                               double&      calculatedTorqueY,
                                               double&      calculatedTorqueZ)
{
    // Cache pointers to the custom properties we wish to use
    double* residenceTimeDelta = particlePropData->getDelta(RESIDENCE_TIME_PROPERTY.c_str());

    // update the residence time for this particle by adding the time step
    // to the current value
    *residenceTimeDelta += timestep;

    return eSuccess;
}

unsigned int CResidenceTime::getNumberOfRequiredProperties(
                                const NApi::EPluginPropertyCategory category)
{
    // this plug-in registers 1 custom particle property
    if (eParticle == category)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

bool CResidenceTime::getDetailsForProperty(
                         unsigned int                    propertyIndex,
                         NApi::EPluginPropertyCategory   category,
                         char                            name[NApi::CUSTOM_PROP_MAX_NAME_LENGTH],
                         NApi::EPluginPropertyDataTypes& dataType,
                         unsigned int&                   numberOfElements,
                         NApi::EPluginPropertyUnitTypes& unitType)
{
    if (eParticle == category &&
        0 == propertyIndex)
    {
        strcpy(name, RESIDENCE_TIME_PROPERTY.c_str());
        dataType         = eDouble;
        numberOfElements = 1;
        unitType         = eTime;
        return true;
    }
    else
    {
        return false;
    }
}